(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10447,        365]
NotebookOptionsPosition[      9362,        321]
NotebookOutlinePosition[      9705,        336]
CellTagsIndexPosition[      9662,        333]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"ux", "-", "Ux"}], ")"}], "^", "3"}], "]"}]], "Input",
 CellChangeTimes->{{3.6652333854347067`*^9, 3.665233411326749*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["ux", "3"], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["ux", "2"], " ", "Ux"}], "+", 
  RowBox[{"3", " ", "ux", " ", 
   SuperscriptBox["Ux", "2"]}], "-", 
  SuperscriptBox["Ux", "3"]}]], "Output",
 CellChangeTimes->{3.665233412534567*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"ux", "-", "Ux"}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{"uy", "-", "Uy"}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{"uz", "-", "Uz"}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.665234958289308*^9, 3.665234978795968*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ux", " ", "uy", " ", "uz"}], "-", 
  RowBox[{"Ux", " ", "uy", " ", "uz"}], "-", 
  RowBox[{"ux", " ", "Uy", " ", "uz"}], "+", 
  RowBox[{"Ux", " ", "Uy", " ", "uz"}], "-", 
  RowBox[{"ux", " ", "uy", " ", "Uz"}], "+", 
  RowBox[{"Ux", " ", "uy", " ", "Uz"}], "+", 
  RowBox[{"ux", " ", "Uy", " ", "Uz"}], "-", 
  RowBox[{"Ux", " ", "Uy", " ", "Uz"}]}]], "Output",
 CellChangeTimes->{3.6652349812057548`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"ux", "-", "Ux"}], ")"}], "^", "2"}], "*", 
   RowBox[{"(", 
    RowBox[{"uy", "-", "Uy"}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6652350670376253`*^9, 3.665235078036113*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["ux", "2"], " ", "uy"}], "-", 
  RowBox[{"2", " ", "ux", " ", "Ux", " ", "uy"}], "+", 
  RowBox[{
   SuperscriptBox["Ux", "2"], " ", "uy"}], "-", 
  RowBox[{
   SuperscriptBox["ux", "2"], " ", "Uy"}], "+", 
  RowBox[{"2", " ", "ux", " ", "Ux", " ", "Uy"}], "-", 
  RowBox[{
   SuperscriptBox["Ux", "2"], " ", "Uy"}]}]], "Output",
 CellChangeTimes->{3.6652350792380753`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"ux", "-", "Ux"}], ")"}], "^", "2"}], "*", 
   RowBox[{"(", 
    RowBox[{"ux", "-", "Ux"}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.665235285108924*^9, 3.665235288876026*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["ux", "3"], "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["ux", "2"], " ", "Ux"}], "+", 
  RowBox[{"3", " ", "ux", " ", 
   SuperscriptBox["Ux", "2"]}], "-", 
  SuperscriptBox["Ux", "3"]}]], "Output",
 CellChangeTimes->{3.665235291918062*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{"1", "/", "n"}], "*", 
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ux", "[", "i", "]"}], "-", "Ux"}], ")"}], "^", "2"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"uz", "[", "i", "]"}], "-", "Uz"}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "0", ",", "n"}], "}"}]}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6652353351359625`*^9, 3.6652353384183865`*^9}, {
  3.665235469081513*^9, 3.665235491832822*^9}, {3.6652355801722608`*^9, 
  3.6652356889244556`*^9}, {3.66523574166329*^9, 3.6652357781472335`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"i", "=", "0"}], "n"], 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "Ux"}], "+", 
       RowBox[{"ux", "[", "i", "]"}]}], ")"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "Uz"}], "+", 
      RowBox[{"uz", "[", "i", "]"}]}], ")"}]}]}], "n"]], "Output",
 CellChangeTimes->{
  3.6652353396467347`*^9, 3.6652355168932877`*^9, {3.665235673513936*^9, 
   3.665235690097102*^9}, 3.6652357791478987`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Sum", "[", 
    RowBox[{
     RowBox[{"Expand", "[", 
      RowBox[{
       RowBox[{"1", "/", "n"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ux", "[", "i", "]"}], "-", "Ux"}], ")"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"uy", "[", "i", "]"}], "-", "Uy"}], ")"}], "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"uz", "[", "i", "]"}], "-", "Uz"}], ")"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}], "/.", 
   RowBox[{
    RowBox[{"uy", "[", "i", "]"}], "\[Rule]", 
    RowBox[{"ux", "[", "i", "]"}]}]}], "/.", 
  RowBox[{"Uy", "\[Rule]", "Ux"}]}]], "Input",
 CellChangeTimes->{{3.665236764045683*^9, 3.6652367697271566`*^9}, {
  3.665237436328154*^9, 3.665237442171824*^9}, {3.6652374810518904`*^9, 
  3.6652374987393093`*^9}}],

Cell[BoxData[
 RowBox[{
  UnderoverscriptBox["\[Sum]", 
   RowBox[{"i", "=", "1"}], "n"], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       SuperscriptBox["Ux", "2"], " ", "Uz"}], "n"]}], "+", 
    FractionBox[
     RowBox[{"2", " ", "Ux", " ", "Uz", " ", 
      RowBox[{"ux", "[", "i", "]"}]}], "n"], "-", 
    FractionBox[
     RowBox[{"Uz", " ", 
      SuperscriptBox[
       RowBox[{"ux", "[", "i", "]"}], "2"]}], "n"], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox["Ux", "2"], " ", 
      RowBox[{"uz", "[", "i", "]"}]}], "n"], "-", 
    FractionBox[
     RowBox[{"2", " ", "Ux", " ", 
      RowBox[{"ux", "[", "i", "]"}], " ", 
      RowBox[{"uz", "[", "i", "]"}]}], "n"], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"ux", "[", "i", "]"}], "2"], " ", 
      RowBox[{"uz", "[", "i", "]"}]}], "n"]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.6652367708783035`*^9, 3.665237448476756*^9, {3.665237486558442*^9, 
   3.665237499752672*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"Expand", "[", 
    RowBox[{
     RowBox[{"1", "/", "n"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ux", "[", "i", "]"}], "-", "Ux"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"uy", "[", "i", "]"}], "-", "Uy"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"uz", "[", "i", "]"}], "-", "Uz"}], ")"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.6652367948266797`*^9, 3.665236831166998*^9}}],

Cell[BoxData[
 RowBox[{
  UnderoverscriptBox["\[Sum]", 
   RowBox[{"i", "=", "1"}], "n"], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"Ux", " ", "Uy", " ", "Uz"}], "n"]}], "+", 
    FractionBox[
     RowBox[{"Uy", " ", "Uz", " ", 
      RowBox[{"ux", "[", "i", "]"}]}], "n"], "+", 
    FractionBox[
     RowBox[{"Ux", " ", "Uz", " ", 
      RowBox[{"uy", "[", "i", "]"}]}], "n"], "-", 
    FractionBox[
     RowBox[{"Uz", " ", 
      RowBox[{"ux", "[", "i", "]"}], " ", 
      RowBox[{"uy", "[", "i", "]"}]}], "n"], "+", 
    FractionBox[
     RowBox[{"Ux", " ", "Uy", " ", 
      RowBox[{"uz", "[", "i", "]"}]}], "n"], "-", 
    FractionBox[
     RowBox[{"Uy", " ", 
      RowBox[{"ux", "[", "i", "]"}], " ", 
      RowBox[{"uz", "[", "i", "]"}]}], "n"], "-", 
    FractionBox[
     RowBox[{"Ux", " ", 
      RowBox[{"uy", "[", "i", "]"}], " ", 
      RowBox[{"uz", "[", "i", "]"}]}], "n"], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"ux", "[", "i", "]"}], " ", 
      RowBox[{"uy", "[", "i", "]"}], " ", 
      RowBox[{"uz", "[", "i", "]"}]}], "n"]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.665236806892251*^9, 3.6652368327940598`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Sum", "[", 
  RowBox[{
   RowBox[{"Expand", "[", 
    RowBox[{
     RowBox[{"1", "/", "n"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"ux", "[", "i", "]"}], "-", "Ux"}], ")"}], "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"uz", "[", "i", "]"}], "-", "Uz"}], ")"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.666867798745492*^9, 3.6668678014904623`*^9}, {
  3.6668679338550305`*^9, 3.6668679547564764`*^9}}],

Cell[BoxData[
 RowBox[{
  UnderoverscriptBox["\[Sum]", 
   RowBox[{"i", "=", "1"}], "n"], 
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     RowBox[{"Ux", " ", "Uz"}], "n"], "-", 
    FractionBox[
     RowBox[{"Uz", " ", 
      RowBox[{"ux", "[", "i", "]"}]}], "n"], "-", 
    FractionBox[
     RowBox[{"Ux", " ", 
      RowBox[{"uz", "[", "i", "]"}]}], "n"], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"ux", "[", "i", "]"}], " ", 
      RowBox[{"uz", "[", "i", "]"}]}], "n"]}], ")"}]}]], "Output",
 CellChangeTimes->{3.666867803381354*^9, 3.666867956606307*^9}]
}, Open  ]]
},
WindowSize->{944, 981},
WindowMargins->{{Automatic, 0}, {Automatic, 0}},
FrontEndVersion->"10.0 for Microsoft Windows (64-bit) (December 4, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 201, 5, 31, "Input"],
Cell[784, 29, 282, 8, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1103, 42, 311, 9, 31, "Input"],
Cell[1417, 53, 442, 10, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1896, 68, 278, 8, 31, "Input"],
Cell[2177, 78, 426, 12, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2640, 95, 276, 8, 31, "Input"],
Cell[2919, 105, 282, 8, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3238, 118, 682, 18, 31, "Input"],
Cell[3923, 138, 543, 17, 49, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4503, 160, 879, 25, 31, "Input"],
Cell[5385, 187, 1022, 32, 55, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6444, 224, 575, 17, 31, "Input"],
Cell[7022, 243, 1184, 35, 93, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8243, 283, 530, 15, 31, "Input"],
Cell[8776, 300, 570, 18, 88, "Output"]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
